Imports System.Collections

Public Class frmRecursiveLambda

    Private Sub frmRecursiveLambda_Load(ByVal sender As Object, _
        ByVal e As EventArgs) Handles MyBase.Load

        Me.TreeView1.ExpandAll()
    End Sub

    Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) _
        Handles btFolders.Click, btContrls.Click, _
        btTreenodesLambda.Click, btRecurseClassic.Click

        Select Case True
            ' Dateisystem enumerieren
            Case sender Is btFolders
                Dim Root = IO.Path.GetFullPath("..\..")
                Dim GetChildren As Func(Of String, IEnumerable) = _
                    Function(S) IO.Directory.GetDirectories(S)
                    Me.ListBox1.DataSource = GetChildren.All(Root).ToList

            ' Alle Controls dieses Forms enumerieren
            Case sender Is btContrls
                Dim GetChildren As Func(Of Control, IEnumerable) = _
                    Function(C) C.Controls

                ' Fr die Anzeige ist ein Select angehngt, der die Namen der 
                '  Controls selektiert
                Me.ListBox1.DataSource = _
                    GetChildren.All(Me).Select(Function(C) C.Name).ToList

            ' Alle Treenodes enumerieren
            Case sender Is btTreenodesLambda
                ' Beachte die eigenwillige Reihenfolge der ListItems
                Dim GetChildren As Func(Of TreeNode, IEnumerable) = _
                    Function(Nd) Nd.Nodes
                ' Hier wird fr die Anzeige Treenode.FullPath selektiert
                Me.ListBox1.DataSource = _
                    GetChildren.AllChildren(Me.TreeView1.Nodes) _
                    .Select(Function(Nd) Nd.FullPath).ToList

            ' klassische Rekursion - "Depth first"
            Case sender Is btRecurseClassic
                Me.ListBox1.DataSource = Nothing
                CollectDepthFirst(Me.TreeView1.Nodes)
        End Select
    End Sub

    Private Sub CollectDepthFirst(ByVal Nodes As TreeNodeCollection)
        ' Klassische rekursive Methode - fr jeden Bedarf muss man eine eigene 
        '  Methode schreiben
        For Each Nd As TreeNode In Nodes
            Me.ListBox1.Items.Add(Nd.FullPath)
            CollectDepthFirst(Nd.Nodes)
        Next
    End Sub

End Class