﻿Imports System.Runtime.CompilerServices
Imports System.Collections

Public Module modExtensions

    <Extension()> _
    Public Function AllChildren(Of T)( _
        ByVal GetChildren As Func(Of T, IEnumerable), _
        ByVal Roots As IEnumerable) As IEnumerable(Of T)

        Dim Enumerate As Func(Of IEnumerable(Of T), IEnumerable(Of T)) = Nothing
        Enumerate = Function(Nd) Nd.Concat(Nd.SelectMany(Function(Nd2) _
            Enumerate(GetChildren(Nd2).Cast(Of T))))
        Return Enumerate(Roots.Cast(Of T))
    End Function

    <Extension()> _
    Public Function All(Of T)(ByVal GetChildren As Func(Of T, IEnumerable), _
        ByVal Root As T) As IEnumerable(Of T)

        ' Root wird in die Enumeration hineingenommen, indem ein es 
        '  enthaltendes IEnumerable(Of T) geschaffen wird, dessen Kinder 
        '  (= nur Root) rekursiv enumeriert werden
        Return GetChildren.AllChildren(New T() {Root})
    End Function

End Module
